<?php
/**
* @author Mikko Rönkkö
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $_PLUGINS;
$_PLUGINS->registerFunction('onAfterUserProfileEditDisplay','getJS','extendedselect');
$_PLUGINS->registerFunction('onAfterRegisterUserDisplay','getJS','extendedselect');
$_PLUGINS->registerFunction('onBeforeUserUpdate','processNewFields','extendedselect');

class extendedselect extends cbPluginHandler{

	function getJS() {
		
		echo "<script src=\"components/com_comprofiler/plugin/user/plug_extendedselect/funcs.js\"></script>";

		$selects =  explode("|*|", $this->params->get('fields',''));
		
		echo "\n<script type=\"text/javascript\">";
		foreach($selects as $select){
			echo("\nenableExtendedSelect('".$select."');");
		}	
		echo "\n</script>";
	}

/*
Checks if there are new values for selects. If such are found, they are inserted as values and in the moderation table
*/
	function processNewFields(&$row,&$rowExtras){
		
		
		$this->_checkThingsFromListTabFields($rowExtras);

		foreach($rowExtras as $name=>$value){
			$this->_check($name,$value);
		}
	}

	function _check($name,$value){

		//Abort if this field is not in the enabled selects
		$selects =  explode("|*|", $this->params->get('fields',''));
		if(array_search($name,$selects)===false) return;
		
		if(strpos($value,'|*|')!==false||$value=='other...'){
			$value='';
		}
		if($value==''){
			return;
		}
		if(is_array($value)){
			foreach($value as $val)
				$this->_check($name,$val);	
		}
		else{
			global $database;
			$sql="select type, fieldid from #__comprofiler_fields where name ='".$name."'";
			$database->setQuery($sql);
			
			$debug.=$database->stderr(true);
			$field=$database->loadObjectList();
			if($field[0]->type=='select'||$field[0]->type=='multiselect'){
				$sql="select count(fieldid) from #__comprofiler_field_values ".
					" where fieldid=".$field[0]->fieldid." and fieldtitle='".$value."'";
				$database->setQuery($sql);
				$count=$database->loadResult();
			$debug.=$database->stderr(true);
				if($count==0){
					$sql="insert into #__comprofiler_field_values (fieldid,fieldtitle,ordering)".
					" values (".$field[0]->fieldid.",'".$value."',999)";
					$database->setQuery($sql);
					$database->query();						
			$debug.=$database->stderr(true);
					$sql="insert into #__comprofiler_field_value_moderation (fieldid,value)".
					" values (".$field[0]->fieldid.",'".$value."')";
					$database->setQuery($sql);
					$database->query();				
				$debug.=$database->stderr(true);
//					die($debug);

				}
				
			}	
		}
	}

	function _checkThingsFromListTabFields(&$rowExtras){

		foreach($_POST as $nameP=>$valueP){
			foreach($rowExtras as $nameR=>$valueR){
				$a=strpos($nameP,$nameR);
				if($a>0&&$a==strlen($nameP)-strlen($nameR)){
					$this->_check($nameR,$valueP);
				}
			}
		}
	}

	function loadSelectList($name,$value,$control_name) {
	
	global $database;

	$database->setQuery("select name, title from #__comprofiler_fields where type='select' or type ='multiselect'");
	$selects = $database->loadObjectList();
	$selectList = array();
	
	$selectList[] = mosHTML::makeOption(-1,'none');
	foreach ($selects as $select) {
			$postfix='[]';
			$selectList[] = mosHTML::makeOption( ($select->name).$postfix, $select->title);
	}
	$valAsObj = (isset($value)&&$value!='') ?
	array_map(create_function('$v', '$o=new stdClass(); $o->value=$v; return $o;'), explode("|*|", $value ))
	:null;

	return moscomprofilerHTML::selectList( $selectList, $control_name .'['. $name .'][]', 'size="4" multiple="multiple"', 'value', 'text', $valAsObj, true );	
		
	}

}
?>
